#include <signal.h>
#include <stdio.h>

void my_handler(int param){
	fprintf(stderr,"Received Quit Signal\n");
}

int main(int argc, char* argv[]){
	
	struct sigaction handler,old_handler;
	sigset_t selected,old;
	
	handler.sa_handler=&my_handler;
	sigaction(SIGQUIT,&handler,&old_handler);

	sigemptyset(&selected);
	sigaddset(&selected,15); /* SIGTERM */
	sigaddset(&selected,SIGQUIT);
	
	while(1){
		sigprocmask(SIG_BLOCK,&selected,&old);
		fprintf(stderr,"Asleep\n");
		sleep(5);
		fprintf(stderr,"Awake, is there anything to do?\n");
		sigprocmask(SIG_UNBLOCK,&selected,&old);
		}	
	return 0;
}
